<?php
if ( !defined( 'IN_CMS' ) ) {
    exit();
}

\IoC::resolve( 'eventmediator' )->attach( 'before_route', function( FastRoute\RouteCollector $r, $request, $response ) {
    $r->addRoute( 'GET', 'language/{language:\\w+}', 'plugins\\language_switcher\\controllers\\LanguageController@change' );
    return true;
} );

\IoC::resolve( 'eventmediator' )->attach( 'after_initialize_backend_menu', function( library\BackendMenu $backendMenu ) {
    $submenu = [];
    $locales = include( dirname( __FILE__ ) . DS . 'config' . DS . 'locales.php' );
    foreach ( $locales as $key => $value ) {
        $submenu[] = ['name' => $value, 'url' => BASE_URL . 'language/' . $key];
    }
    $i18n = \IoC::resolve( 'i18n' );
    $backendMenu->push( ['name' => $i18n->__( 'language' ), 'url' => '#', 'submenu' => $submenu] );
    return true;
} );

\IoC::resolve( 'eventmediator' )->attach( 'before_render', function( $controller, $request, $response ) {
    $latte = \IoC::resolve( 'view' )->getLatte();
    $latte->getLoader()->addLoader( new LatteFileLoader( dirname( __FILE__ ) . DS . TEMPLATES_DIR ) );
    $controller->locales = include( dirname( __FILE__ ) . DS . 'config' . DS . 'locales.php' );
    return true;
} );

// $logger = \IoC::resolve( 'logger' );
// $logger->write( sprintf( '[%s] [%s] [%s] Plugin language_switcher initialized.', date( 'Y-m-d H:i:s' ), __FILE__, 'info' ) );
